!******************************************************************************!
!                                                                              !
!    ctparameter75.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016,2017 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter75.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-01-12 12:33             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter75
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter75()
  dZA_QED2 = (8d0*Nc*Ten127*cMU_reg**2d0*coupl(nGC_2)**2d0 + 8d0*Nc*Ten128*    &
             cMC_reg**2d0*coupl(nGC_2)**2d0 + 8d0*Nc*Ten129*cMT**2d0*coupl(    &
             nGC_2)**2d0 + 8d0*Nc*Ten130*cMD_reg**2d0*coupl(nGC_1)**2d0 + 8d0* &
             Nc*Ten131*cMS_reg**2d0*coupl(nGC_1)**2d0 + 8d0*Nc*Ten132*cMB_reg**&
             2d0*coupl(nGC_1)**2d0 - 16d0*Nc*Ten133*coupl(nGC_2)**2d0 - 16d0*Nc&
             *Ten134*coupl(nGC_2)**2d0 - 16d0*Nc*Ten135*coupl(nGC_2)**2d0 -    &
             16d0*Nc*Ten136*coupl(nGC_1)**2d0 - 16d0*Nc*Ten137*coupl(nGC_1)**  &
             2d0 - 16d0*Nc*Ten138*coupl(nGC_1)**2d0 - 4d0*Nc*Ten139*coupl(nGC_2&
             )**2d0/3d0 - 4d0*Nc*Ten140*coupl(nGC_2)**2d0/3d0 - 4d0*Nc*Ten141* &
             coupl(nGC_1)**2d0/3d0 - 4d0*Nc*Ten142*coupl(nGC_1)**2d0/3d0 - 4d0*&
             Nc*Ten143*coupl(nGC_1)**2d0/3d0 - 4d0*Nc*coupl(nGC_2)**2d0/3d0 -  &
             Ten364*(8d0*coupl(nGC_3)**2d0 + coupl(nGC_4)**2d0) - Ten365*(13d0*&
             coupl(nGC_3)**2d0 + 3d0*coupl(nGC_4)**2d0) - Ten366*(13d0*coupl(  &
             nGC_3)**2d0 + 3d0*coupl(nGC_4)**2d0) - 2d0*Ten380*(17d0*coupl(    &
             nGC_3)**2d0 + 3d0*coupl(nGC_4)**2d0) + 8d0*Ten381*cME_reg**2d0*   &
             coupl(nGC_4)**2d0 + 8d0*Ten382*cMM_reg**2d0*coupl(nGC_4)**2d0 +   &
             8d0*Ten383*cMTA_reg**2d0*coupl(nGC_4)**2d0 - 16d0*Ten384*coupl(   &
             nGC_4)**2d0 - 16d0*Ten385*coupl(nGC_4)**2d0 - 16d0*Ten386*coupl(  &
             nGC_4)**2d0 + 4d0*Ten387*coupl(nGC_51)**2d0 - 4d0*Ten388*coupl(   &
             nGC_4)**2d0/3d0 - 4d0*Ten389*coupl(nGC_4)**2d0/3d0 - 4d0*Ten390*  &
             coupl(nGC_4)**2d0/3d0 - 4d0*coupl(nGC_3)**2d0/3d0)/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZA_QED2 = cone*real(dZA_QED2,kind=dp)
    end if 
end subroutine set_ctparameter75
end module ctparameter75
